#include <iostream>
#include <list>
#include <stack>
#include <cstring>
#include <set>
#include <vector>
using namespace std;

class Graph
{
    int V;

    list<int> *adj;

    void topologicalSortUtil(int v, bool visited[], stack<int> &Stack);
public:
    Graph(int V);

    void addEdge(int v, int w);

    void topologicalSort(set<char>);
};

Graph::Graph(int V)
{
    this->V = V;
    adj = new list<int>[V];
}

void Graph::addEdge(int v, int w)
{
    adj[v].push_back(w);
}

void Graph::topologicalSortUtil(int v, bool visited[], stack<int> &Stack)
{
    visited[v] = true;

    list<int>::iterator i;
    for (i = adj[v].begin(); i != adj[v].end(); ++i)
        if (!visited[*i])
            topologicalSortUtil(*i, visited, Stack);

    Stack.push(v);
}

void Graph::topologicalSort(set<char> used)
{
    stack<int> Stack;

    bool *visited = new bool[V];
    for (int i = 0; i < V; i++)
        visited[i] = false;

    for (int i = 0; i < V; i++)
        if (visited[i] == false)
            topologicalSortUtil(i, visited, Stack);

    while (Stack.empty() == false)
    {
        char c = (char) ('a' + Stack.top());
        if(used.find(c) != used.end()) {
            cout << c;
        }
        Stack.pop();
    }
    cout << '\n';
}

int min(int x, int y)
{
    return (x < y)? x : y;
}

void printOrder(vector<string> words, int n, set<char> used)
{
    int alpha = 26;
    Graph g(alpha);

    for (int i = 0; i < n-1; i++)
    {
        string word1 = words[i], word2 = words[i+1];
        for (int j = 0; j < min(word1.length(), word2.length()); j++)
        {
            if (word1[j] != word2[j])
            {
                g.addEdge(word1[j]-'a', word2[j]-'a');
                break;
            }
        }
    }

    g.topologicalSort(used);
}

int main()
{
    freopen("extra.in", "r", stdin);
    freopen("extra.out", "w", stdout);

    int N;
    cin >> N;
    vector<string> words(N);
    for(int i = 0; i < N; i++) {
        cin >> words[i];
    }
    
    std::set<char> used;
    for(const string& s : words) {
        for(const char& c : s) {
            used.insert(c);
        }
    }
    
    printOrder(words, (int)words.size(), used);
    return 0;
}

