

#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <cstring>
#include <cstdlib>

using namespace std;
ifstream in("boss.in");
ofstream out("boss.out");

#define dim 30

const int nr_of_Bits = 64;
int n;
long long v[dim];

long long formula(long long x, int index)
{
    return ( (x >> index) & 1);
}

bitset<nr_of_Bits>uz;
vector<int>G[1048577];
vector<int>Graph[100];
vector<int>sol;
bool mat[64][64];

void DFS(int s)
{
	uz[s]=1;
	for(vector<int>::iterator I=Graph[s].begin();I<Graph[s].end();I++)
		if(!uz[*I])
			DFS(*I);
}

int main()
{

    in >> n;
    for(int i = 1; i <=n; ++i)
    {
        in >> v[i];
    }


    //make the subsets;

    int lim = 1 << n;

    for( int i=1 ; i < lim ; i++)
    {
        for( int j = 1 ; j<=n ; j++)
        {
            if ( i & ( 1 << ( j - 1  ) ) )
                {
                    G[i].push_back(j);
                }
        }
    }

    int sum = 64;
    for(int i = 1; i < lim; ++i)
    {
        for(int j = 0; j < G[i].size(); ++j)
        {
            //see the bits
            sol.clear();
            long long numberToCheck = v[G[i][j]];
            for(int k = 0; k <64; ++k)
            {
                if(formula(numberToCheck,k) == 1)
                {
                    sol.push_back(k);
                }
            }


            for(int index = 0; index < sol.size() - 1; ++index)
            {
                for(int nextIndex = index + 1; nextIndex < sol.size(); ++nextIndex)
                    if(!mat[sol[index]][sol[nextIndex]] && !mat[sol[nextIndex]][sol[index]])
                {
                    Graph[sol[index]].push_back(sol[nextIndex]);
                    Graph[sol[nextIndex]].push_back(sol[index]);

                    mat[sol[index]][sol[nextIndex]] = 1;
                    mat[sol[nextIndex]][sol[index]] = 1;
                }
            }
        }

        int partialSol = 0;
        for(int bitNr = 0; bitNr < 64; ++bitNr)
        {
            if(!uz[bitNr])
            {
                ++partialSol;
                DFS(bitNr);
            }
        }

        sum = sum + partialSol;

        //clear
        for(int i = 0; i < 64; ++i)
        {
            Graph[i].clear();
        }

        uz.reset();
        memset(mat, false, sizeof(mat));
        sol.clear();
    }

    out << sum << '\n';

    return 0;
}
