

#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <cstring>
#include <cstdlib>

using namespace std;
ifstream in("boss.in");
ofstream out("boss.out");

#define dim 30

const int nr_of_Bits = 64;
int n;
long long v[dim];
int T[nr_of_Bits];

long long formula(long long x, int index)
{
    return ( (x >> index) & 1);
}

int search(int nod)
{
    if(nod != T[nod])
        return T[nod] = search(T[nod]);
    return nod;
}

void unire(int nod1, int nod2)
{
    int m1 = search(nod1);
    int m2 = search(nod2);

    T[m2] = m1;
}

void init()
{
    for(int i = 0; i < nr_of_Bits; ++i)
        T[i] = i;
}

int count_connected_components()
{
    int result = 0;
    for (int i = 0; i < nr_of_Bits; ++i) {
        if (i == search(i)) {
            ++result;
        }
    }
    return result;
}

int main()
{

    in >> n;
    for(int i = 1; i <=n; ++i)
    {
        in >> v[i];
    }

    //make the subsets;

    int lim = 1 << n;
    int sum = 64;
    for( int i=1 ; i < lim ; i++)
    {
        init();
        for( int j = 1 ; j<=n ; j++)
        {
            if ( i & ( 1 << ( j - 1  ) ) )
            {
                    long long numberToCheck = v[j];
                    int bitFound = -1;
                    for(int bit = 0; bit < nr_of_Bits; ++bit)
                    {
                        if(formula(numberToCheck, bit))
                        {
                            if(bitFound == -1)
                            {
                                bitFound = bit;
                            }
                            unire(bitFound, bit);
                        }
                    }
            }
        }
        sum = sum + count_connected_components();
    }


    out << sum << '\n';
}

